#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <iomanip>
#include <limits>
#include <math.h>
#include <TArc.h>
#include <TArrow.h>
#include <TBox.h>
#include <TBrowser.h>
#include <TCanvas.h>
#include <TCondition.h>
#include <TDatime.h>
#include <TDirectory.h>
#include <TEllipse.h>
#include <TGraphErrors.h>
#include <TGButton.h>
#include <TGButtonGroup.h>
#include <TGClient.h>
#include <TGComboBox.h>
#include <TGProgressBar.h>
#include <TGLabel.h>
#include <TGTextEntry.h>
#include <TGFrame.h>
#include <TGraph.h>
#include <TGraphErrors.h>
#include <TF1.h>
#include <TFile.h>
#include <TH1D.h>
#include <TH2D.h>
#include <TLatex.h>
#include <TLeaf.h>
#include <TLine.h>
#include "TMath.h"
#include <TObjectTable.h>
#include <TPaveText.h>
#include <TPolyLine.h>
#include <TProfile.h>
#include <TRandom.h>
#include <TRootEmbeddedCanvas.h>
#include <TStyle.h>
#include "TSystem.h"
#include <TTree.h>
#include <TVectorD.h>
#include <TDatime.h>
#include <sys/types.h>
#include <time.h>
#include <TROOT.h>
#include <TError.h>
#include "TVirtualFFT.h"
#define SizeOfArray(a) (sizeof(a)/sizeof(a[0]))
#include <classes/myCovariance.C>
#include <classes/MIPcounter2012.C>
#include <classes/myRCCR.C>
#include <classes/parabola2012.C>
#include <classes/interpolate2012.C>
#include <classes/RingBuffer.C>
#include <classes/EventHeader.C>
#include <classes/BurstHeader.C>
#include <classes/RunHeader.C>
#include <classes/ProcessingStatus.C>
#include <classes/CherenkovBuffer.C>
#include <classes/CherenkovCalibration.C>
#include <classes/TimingCuts.C>
#include <classes/TReference.C>
#include <classes/TSignal.C>
#include <classes/TChannel.C>
#include <classes/TModule.C>
#include <classes/SetMIPrunHVgroup.C>
#include <classes/DisplaySpike.C>
#include <classes/DisplayModules.C>
#include <classes2014/EventPrehistory.C>


using std::ios;
using std::cout;
using std::cin;
using std::endl;
using std::istringstream;
using std::ostringstream;

double prehistoryTime[11]={0.02e6, 0.05e6, 0.10e6, 0.20e6, 0.50e6,
                           1.00e6, 2.00e6, 5.00e6, 10.0e6, 20.0e6, 50.0e6};// ns!!
double prevRate[11];
TFile *PreHistoryFile;  // PreHistory
/*
struct EventPrehistory {
  int run;
  int spill;
  int event;
  int burstEvent;
  int IRF;
  double integralGADCflat[11];
  double integralGADCtriang[11];
  char SpillFileName[100];
  
  void Print() {
    printf("\nrun#%04d spill#%03d evt#%05d(%03d) spill=%s\n", 
           run, spill, event, burstEvent, SpillFileName);
    for (int i=0; i<11; i++) {
      printf("integrals#%02d -> %7.2e, %7.2e GADC/bunch\n",
              i, integralGADCflat[i],
                 integralGADCtriang[i]);
    }
  }
} myEventPrehistory;
*/
EventPrehistory myEventPrehistory;

char myText[200];
char fName[200];
char treeName[200];

int iqq=1;
int iCol=1;

//===================================================
int PrehistoryROOTcheck() {
//===================================================

TCanvas *historyCanvas = new TCanvas("historyCanvas", "History", 0, 0, 800, 1000);
TH1F    *historyDummy  = new TH1F("historyDummy", "", 200, -0.5, 199.5); 
historyDummy -> GetXaxis() -> SetTitle("Event# in Spill");
historyDummy -> GetYaxis() -> SetTitle("Prehistory, GADC/166ns");
historyDummy -> GetYaxis() -> SetTitleOffset(1.4);
historyDummy -> SetStats(0);

TLatex  *myLatex       = new TLatex();
TLine   *myLine        = new TLine();
myLatex->SetTextSize(0.03);


double spillMax=0.;
int iEvtMax=0;
int spillOld=-1;

int myRun=1117;
//myRun=1194;
myRun=1098;

sprintf(fName, "/raid04/HiLum/analysis2012/reports/ntuples/v2/run%04d_prehistory.root", myRun);
PreHistoryFile = new TFile(fName, "READONLY");
sprintf(treeName, "prehistory_run%04d", myRun);
TTree *PreHistoryTree = (TTree*)PreHistoryFile->Get(treeName);
PreHistoryTree->SetBranchAddress("myEventPrehistory", &myEventPrehistory.run);

int nEnt=(Int_t)PreHistoryTree->GetEntries();
for (int iEnt=0; iEnt<nEnt; iEnt++) {
  PreHistoryTree->GetEntry(iEnt);
  myEventPrehistory.Print();
  if (spillOld != myEventPrehistory.spill) {
    if (spillOld != -1) {
      iCol=1;
      myLatex->SetTextAlign(12);
      for (int iRate=1; iRate<11; iRate+=4) {
        sprintf(myText, "#bullet T_{INT}=%.2fms", prehistoryTime[iRate]/1.0e6);
        myLatex->SetTextColor(iCol);
        myLatex->DrawLatex(5., (1.01-0.05*iCol)*spillMax, myText);
        iCol++;
      }  
      historyCanvas->Update();
      printf("Spill done, push -> ");
      cin >> iqq;
    }
    if (iqq > 0) {
      historyCanvas->Clear();
      historyCanvas->cd(0)->SetGrid(1);
      gPad->SetRightMargin(0.02);
      gPad->SetLeftMargin(0.12);
      sprintf(myText, "Run#%d Spill#%d", myEventPrehistory.run, myEventPrehistory.spill);
      historyDummy->SetTitle(myText);
      historyDummy->Draw();
      for (int i=0; i<11; i++) {
        prevRate[i]=0.;
      }
    } else if (iqq==-1) {
      PreHistoryFile->Close();
      exit(-1);
    }
    spillOld = myEventPrehistory.spill;
    spillMax=0.;
    iEvtMax=0;    
  }
  if (iqq==0) {
    sprintf(myText, "plots20151029/run%04dspill%04d.ps", myEventPrehistory.run, myEventPrehistory.spill);
    historyCanvas->Print(myText);
    break;
  }
  for (int iRate=0; iRate<11; iRate++) {
    if (spillMax<myEventPrehistory.integralGADCflat[iRate]) {
      spillMax=myEventPrehistory.integralGADCflat[iRate];
    }
    if (spillMax<myEventPrehistory.integralGADCtriang[iRate]) {
      spillMax=myEventPrehistory.integralGADCtriang[iRate];
    }
  }
  historyDummy->GetYaxis()->SetRangeUser(0., 1.01*spillMax);
  historyDummy->GetXaxis()->SetRangeUser(-0.5, myEventPrehistory.burstEvent+0.5);
  iCol=1;
  myLatex->SetTextAlign(22);
  for (int iRate=1; iRate<11; iRate+=4) {
    myLine->SetLineColor(iCol);
    myLine->SetLineWidth(3);
//    myLine->DrawLine(myEventPrehistory.burstEvent-0.45, myEventPrehistory.integralGADCflat[iRate],
//                     myEventPrehistory.burstEvent+0.45, myEventPrehistory.integralGADCflat[iRate]);
    if (myEventPrehistory.burstEvent>0) {
       myLine->DrawLine(myEventPrehistory.burstEvent,   myEventPrehistory.integralGADCtriang[iRate],
                        myEventPrehistory.burstEvent-1, prevRate[iRate]);
    }
    myLatex->SetTextColor(iCol);
    myLatex->DrawLatex(myEventPrehistory.burstEvent, myEventPrehistory.integralGADCtriang[iRate], "#bullet");
    iCol++;
  }
  for (int i=0; i<11; i++) {
    prevRate[i]=myEventPrehistory.integralGADCtriang[i];
  }  
  historyCanvas->Update();
}
PreHistoryFile->Close();

}
